Subject: Re: Another question about importing SVN with fast-import

From: "Shawn O. Pearce" <[email-masked]>
Date: Mon, 16 Jul 2007 23:38:40 -0400

Julian Phillips <[email-masked]> wrote:
> First off, I would just like to say fast-import rocks.  It's well named 
> too ...

I'm glad you like it.  ;-)
 
> Now the question.  Shawn recently added C and R operations - almost as 
> soon as they were asked for too.

Sometimes I'm responsive...

> However, how do you copy a file from a 
> particular revision?

and sometimes not so much.  You can't do that right now.  I've wanted
to open up the data subcommand to allow another form that lets you
specify data from a branch and file path (thus selecting a blob
from another revision) but I haven't gotten around to it.  I also
don't have time to do it during the earlier part of this week.
Maybe I'll get to it later near the end of the week.

It shouldn't be too difficult now with the tree_content_get()
function that I recently defined for the C/R commands.  The SHA-1
comes back in the tree_entry leaf, but that codepath is only valid
for the tip of a branch that fast-import knows about in memory.
If it doesn't then you probably need to fallback into raw tree
parsing.  Ugh.

The way prior frontends have handled this is they assigned marks
to every blob, and then had a translation table within the frontend
of revision->mark, so that anytime it needed a given revision of a
file it knew what mark to send to fast-import.  This does require
that the frontend maintain basically everything...

> I have just hit a point where someone deleted a 
> directory, and then copied one of the files from that directory back from 
> an old revision (as two separate commits).  Since I'm not tracking any 
> branch contents in my front-end, and the copy operation only works from 
> the current branch head I seem to be stuck ... or have I missed something?

Yea, I got nothing.  I can't think of any method to make that work
aside from using marks.  Or teaching fast-import how to do tree
lookup, like I described above.

-- 
Shawn.